package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.user.bo.UserCertificateAddBo;
import com.zhongzheng.modules.user.bo.UserCertificateEditBo;
import com.zhongzheng.modules.user.bo.UserCertificateQueryBo;
import com.zhongzheng.modules.user.domain.UserCertificate;
import com.zhongzheng.modules.user.mapper.UserCertificateMapper;
import com.zhongzheng.modules.user.service.IUserCertificateService;
import com.zhongzheng.modules.user.vo.UserCertificateVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 用户证书Service业务层处理
 *
 * @author hjl
 * @date 2022-02-17
 */
@Service
public class UserCertificateServiceImpl extends ServiceImpl<UserCertificateMapper, UserCertificate> implements IUserCertificateService {

    @Override
    public UserCertificateVo queryById(Long id){
        UserCertificate db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, UserCertificateVo.class);
    }

    @Override
    public List<UserCertificateVo> queryList(UserCertificateQueryBo bo) {
        LambdaQueryWrapper<UserCertificate> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getUserId() != null, UserCertificate::getUserId, bo.getUserId());
        lqw.eq(bo.getGradeId() != null, UserCertificate::getGradeId, bo.getGradeId());
        lqw.eq(bo.getGoodsId() != null, UserCertificate::getGoodsId, bo.getGoodsId());
        lqw.eq(bo.getCertificateTpId() != null, UserCertificate::getCertificateTpId, bo.getCertificateTpId());
        lqw.eq(StrUtil.isNotBlank(bo.getCertificateCode()), UserCertificate::getCertificateCode, bo.getCertificateCode());
        lqw.eq(bo.getTrainStartTime() != null, UserCertificate::getTrainStartTime, bo.getTrainStartTime());
        lqw.eq(bo.getTrainEndTime() != null, UserCertificate::getTrainEndTime, bo.getTrainEndTime());
        lqw.eq(bo.getClassHours() != null, UserCertificate::getClassHours, bo.getClassHours());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserCertificateVo> entity2Vo(Collection<UserCertificate> collection) {
        List<UserCertificateVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserCertificateVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserCertificate> page = (Page<UserCertificate>)collection;
            Page<UserCertificateVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserCertificateAddBo bo) {
        UserCertificate add = BeanUtil.toBean(bo, UserCertificate.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserCertificateEditBo bo) {
        UserCertificate update = BeanUtil.toBean(bo, UserCertificate.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserCertificate entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
